package phuturewarez.spawnerz.items;

import cpw.mods.fml.relauncher.Side;
import cpw.mods.fml.relauncher.SideOnly;
import phuturewarez.spawnerz.Spawnerz;
import phuturewarez.spawnerz.lib.Reference;
import net.minecraft.client.renderer.texture.IIconRegister;
import net.minecraft.entity.player.EntityPlayer;
import net.minecraft.init.Blocks;
import net.minecraft.item.Item;
import net.minecraft.item.ItemStack;
import net.minecraft.tileentity.TileEntityMobSpawner;
import net.minecraft.world.World;

public class SlimeSpawner extends Item {

	public SlimeSpawner() {
		super();
		this.setUnlocalizedName("spawnerSlime");
		this.setCreativeTab(Spawnerz.spawnerzTab);
		this.setMaxStackSize(16);
	}
	
	@Override
	@SideOnly(Side.CLIENT)
	public void registerIcons(IIconRegister iconReg) {
		itemIcon = iconReg.registerIcon(Reference.MOD_ID + ":" + (this.getUnlocalizedName().substring(this.getUnlocalizedName().indexOf(".")+1)));
	}

	public boolean onItemUse(ItemStack item, EntityPlayer entity, World world, int x, int y, int z, int side, float fineX, float fineY, float fineZ) {
		if (!world.isRemote) {
			// Run client code
			Spawnerz.log.info("Slime spawner used on block (" + x + ", " + y + ", " + z + ")");
	        if (side == 0)
	        {
	            --y;
	        }

	        if (side == 1)
	        {
	            ++y;
	        }

	        if (side == 2)
	        {
	            --z;
	        }

	        if (side == 3)
	        {
	            ++z;
	        }

	        if (side == 4)
	        {
	            --x;
	        }

	        if (side == 5)
	        {
	            ++x;
	        }
            if (world.isAirBlock(x, y, z))
            {
                world.setBlock(x, y, z, Blocks.mob_spawner);
                TileEntityMobSpawner spawnerentity = (TileEntityMobSpawner)world.getTileEntity(x, y, z);
                // Function func_145881_a retrieves the MobSpawnerBaseLogic
                spawnerentity.func_145881_a().setEntityName("Slime");
                world.markBlockForUpdate(x, y, z);
                --item.stackSize;
            }			
		} else {
			// Run server code
		}
		return false;
	}

}
