package phuturewarez.spawnerz;

import java.io.File;

import org.apache.logging.log4j.LogManager;
import org.apache.logging.log4j.Logger;

import phuturewarez.spawnerz.FMLEventHooks;
import phuturewarez.spawnerz.items.AddedItems;
import phuturewarez.spawnerz.lib.ConfigHandler;
import phuturewarez.spawnerz.lib.Reference;
import phuturewarez.spawnerz.tabs.TabSpawnerz;
import net.minecraft.creativetab.CreativeTabs;
import net.minecraft.init.Blocks;
import net.minecraft.init.Items;
import net.minecraft.item.Item;
import net.minecraft.item.ItemStack;
import net.minecraft.stats.Achievement;
import net.minecraft.stats.AchievementList;
import net.minecraft.util.RegistryNamespaced;
import cpw.mods.fml.common.FMLCommonHandler;
import cpw.mods.fml.common.Mod;
import cpw.mods.fml.common.SidedProxy;
import cpw.mods.fml.common.Mod.EventHandler;
import cpw.mods.fml.common.Mod.Instance;
import cpw.mods.fml.common.event.FMLInitializationEvent;
import cpw.mods.fml.common.event.FMLPostInitializationEvent;
import cpw.mods.fml.common.event.FMLPreInitializationEvent;
import cpw.mods.fml.common.registry.GameData;
import cpw.mods.fml.common.registry.GameRegistry;
import cpw.mods.fml.common.registry.LanguageRegistry;
import net.minecraftforge.common.MinecraftForge;
import net.minecraftforge.common.config.Configuration;
import net.minecraftforge.common.config.Property;
import net.minecraftforge.oredict.OreDictionary;
import net.minecraftforge.oredict.ShapelessOreRecipe;

// Switch these lines when the config is finally added
//@Mod(name = Reference.MOD_NAME, modid = Reference.MOD_ID, version = Reference.MOD_VER, guiFactory = "phuturewarez.spawnerz.lib.GUIFactory")
@Mod(name = Reference.MOD_NAME, modid = Reference.MOD_ID, version = Reference.MOD_VER)
public class Spawnerz {

    @Instance(value = Reference.MOD_ID)
    public static Spawnerz instance;
	public static Configuration config;
    public static final String modId = Reference.MOD_ID;
	public static Logger log = LogManager.getLogger("Spawnerz");
	public static CreativeTabs spawnerzTab = new TabSpawnerz(CreativeTabs.getNextID(), "spawnerzTab");
    
    @EventHandler
    public void preInit(FMLPreInitializationEvent event) {
    	// Uncomment these when the config is finally added
    	//config = new Configuration(event.getSuggestedConfigurationFile());
    	//ConfigHandler.syncConfig();
    	AddedItems.initItems();
    	GameRegistry.addRecipe(new ItemStack(AddedItems.spawnerEmpty), new Object[]{
			"AAA",
			"ABA",
			"AAA",
			'A', Blocks.iron_bars,
			'B', Items.ender_pearl
		});
    	GameRegistry.addShapelessRecipe(new ItemStack(AddedItems.spawnerBlaze), new Object[]{
			AddedItems.spawnerEmpty,
			Items.blaze_rod
		});
    	GameRegistry.addShapelessRecipe(new ItemStack(AddedItems.spawnerCaveSpider), new Object[]{
			AddedItems.spawnerEmpty,
			Items.string
		});
    	GameRegistry.addShapelessRecipe(new ItemStack(AddedItems.spawnerChicken), new Object[]{
			AddedItems.spawnerEmpty,
			Items.chicken
		});    	
    	GameRegistry.addShapelessRecipe(new ItemStack(AddedItems.spawnerCow), new Object[]{
			AddedItems.spawnerEmpty,
			Items.beef
		});
    	GameRegistry.addShapelessRecipe(new ItemStack(AddedItems.spawnerCreeper), new Object[]{
			AddedItems.spawnerEmpty,
			Items.gunpowder
		});
    	GameRegistry.addShapelessRecipe(new ItemStack(AddedItems.spawnerEnderman), new Object[]{
			AddedItems.spawnerEmpty,
			Items.ender_pearl
		});
    	GameRegistry.addShapelessRecipe(new ItemStack(AddedItems.spawnerGhast), new Object[]{
			AddedItems.spawnerEmpty,
			Items.ghast_tear
		});
    	GameRegistry.addShapelessRecipe(new ItemStack(AddedItems.spawnerMagmaCube), new Object[]{
			AddedItems.spawnerEmpty,
			Items.magma_cream
		});
    	GameRegistry.addShapelessRecipe(new ItemStack(AddedItems.spawnerMooshroom), new Object[]{
			AddedItems.spawnerEmpty,
		    Blocks.red_mushroom
		});
    	GameRegistry.addShapelessRecipe(new ItemStack(AddedItems.spawnerOcelot), new Object[]{
			AddedItems.spawnerEmpty,
			Items.fish
		});
    	GameRegistry.addShapelessRecipe(new ItemStack(AddedItems.spawnerPig), new Object[]{
			AddedItems.spawnerEmpty,
			Items.porkchop
		});
    	GameRegistry.addShapelessRecipe(new ItemStack(AddedItems.spawnerSheep), new Object[]{
			AddedItems.spawnerEmpty,
			Blocks.wool
		});
    	GameRegistry.addShapelessRecipe(new ItemStack(AddedItems.spawnerSkeleton), new Object[]{
			AddedItems.spawnerEmpty,
			Items.arrow
		});
    	GameRegistry.addShapelessRecipe(new ItemStack(AddedItems.spawnerSlime), new Object[]{
			AddedItems.spawnerEmpty,
			Items.slime_ball
		});
    	GameRegistry.addShapelessRecipe(new ItemStack(AddedItems.spawnerSpider), new Object[]{
			AddedItems.spawnerEmpty,
			Items.spider_eye
		});
    	GameRegistry.addShapelessRecipe(new ItemStack(AddedItems.spawnerVillager), new Object[]{
			AddedItems.spawnerEmpty,
			Items.emerald
		});
    	GameRegistry.addShapelessRecipe(new ItemStack(AddedItems.spawnerWolf), new Object[]{
			AddedItems.spawnerEmpty,
			Items.bone
		});
    	GameRegistry.addShapelessRecipe(new ItemStack(AddedItems.spawnerZombiePigman), new Object[]{
			AddedItems.spawnerEmpty,
			Items.gold_nugget
		});
    	GameRegistry.addShapelessRecipe(new ItemStack(AddedItems.spawnerZombie), new Object[]{
			AddedItems.spawnerEmpty,
			Items.rotten_flesh
		});
    }
       
    @EventHandler
    public void load(FMLInitializationEvent event) {
        FMLCommonHandler.instance().bus().register(new FMLEventHooks());
    }
       
    @EventHandler
    public void postInit(FMLPostInitializationEvent event) {
    }
}